telegram-bot-bash/bashbot.sh

773 lines
26 KiB
Bash
Raw Normal View History

#!/bin/bash
2015-07-10 05:43:08 +00:00
# bashbot, the Telegram bot written in bash.
2019-04-01 10:52:25 +00:00
# Written by Drew (@topkecleon) and Daniil Gentili (@danogentili), KayM (@gnadelwartz).
# Also contributed: JuanPotato, BigNerd95, TiagoDanin, iicc1.
# https://github.com/topkecleon/telegram-bot-bash
# Depends on JSON.sh (http://github.com/dominictarr/JSON.sh) (MIT/Apache),
# and on tmux (http://github.com/tmux/tmux) (BSD).
2015-07-10 05:43:08 +00:00
# This file is public domain in the USA and all free countries.
# Elsewhere, consider it to be WTFPLv2. (wtfpl.net/txt/copying)
#
2019-04-19 15:31:01 +00:00
#### $$VERSION$$ 0.70-dev-11-g41b8e69
2019-04-01 10:52:25 +00:00
#
# Exit Codes:
# - 0 sucess (hopefully)
# - 1 can't change to dir
2019-04-12 09:27:20 +00:00
# - 2 can't write to tmp, count or token
# - 3 user / command not found
2019-04-01 10:52:25 +00:00
# - 4 unkown command
# - 5 cannot connect to telegram bot
2019-03-22 16:47:36 +00:00
# are we runnig in a terminal?
2019-03-31 10:12:55 +00:00
if [ -t 1 ] && [ "$TERM" != "" ]; then
CLEAR='clear'
RED='\e[31m'
GREEN='\e[32m'
ORANGE='\e[35m'
NC='\e[0m'
fi
2019-03-31 10:12:55 +00:00
# get location of bashbot.sh an change to bashbot dir
SCRIPT="./$(basename "$0")"
SCRIPTDIR="$(dirname "$0")"
RUNUSER="${USER}" # USER is overwritten by bashbot array, $USER may not work later on...
2019-03-31 10:52:11 +00:00
if ! cd "${SCRIPTDIR}" ; then
echo -e "${RED}ERROR: Can't change to ${SCRIPTDIR} ...${NC}"
exit 1
fi
2019-03-22 16:47:36 +00:00
if [ ! -w "." ]; then
echo -e "${ORANGE}WARNING: ${SCRIPTDIR} is not writeable!${NC}"
2019-03-22 16:47:36 +00:00
ls -ld .
fi
2019-04-19 15:31:01 +00:00
TOKENFILE="./token"
if [ ! -f "${TOKENFILE}" ]; then
if [ "${CLEAR}" = "" ] && [ "$1" != "init" ]; then
2019-04-12 09:27:20 +00:00
echo "Running headless, run ${SCRIPT} init first!"
exit 2
else
${CLEAR}
echo -e "${RED}TOKEN MISSING.${NC}"
echo -e "${ORANGE}PLEASE WRITE YOUR TOKEN HERE OR PRESS CTRL+C TO ABORT${NC}"
read -r token
2019-04-19 15:31:01 +00:00
echo "${token}" > "${TOKENFILE}"
2019-04-12 09:27:20 +00:00
fi
fi
if [ ! -f "JSON.sh/JSON.sh" ]; then
2019-04-19 15:31:01 +00:00
echo "Seems to be first run, Downloading JSON.sh..."
git clone https://github.com/dominictarr/JSON.sh/ 2>&1
echo "JSON.sh has been downloaded. Proceeding."
fi
BOTADMIN="./botadmin"
if [ ! -f "${BOTADMIN}" ]; then
2019-04-12 17:39:21 +00:00
if [ "${CLEAR}" = "" ]; then
2019-04-12 09:27:20 +00:00
echo "Running headless, set botadmin to AUTO MODE!"
2019-04-12 17:39:21 +00:00
echo '?' > "${BOTADMIN}"
2019-04-12 09:27:20 +00:00
else
${CLEAR}
echo -e "${RED}BOTADMIN MISSING.${NC}"
2019-04-12 09:27:20 +00:00
echo -e "${ORANGE}PLEASE WRITE YOUR TELEGRAM ID HERE OR ENTER '?'${NC}"
echo -e "${ORANGE}TO MAKE FIRST USER TYPING '/start' TO BOTADMIN${NC}"
read -r token
2019-04-12 09:27:20 +00:00
echo "${token}" > "${BOTADMIN}"
fi
fi
2019-04-12 11:14:33 +00:00
BOTACL="./botacl"
if [ ! -f "${BOTACL}" ]; then
echo -e "${ORANGE}Create empty ${BOTACL} file.${NC}"
touch "${BOTACL}"
fi
2019-03-22 16:47:36 +00:00
TMPDIR="./tmp-bot-bash"
if [ ! -d "${TMPDIR}" ]; then
mkdir "${TMPDIR}"
elif [ ! -w "${TMPDIR}" ]; then
${CLEAR}
echo -e "${RED}ERROR: Can't write to ${TMPDIR}!.${NC}"
ls -ld "${TMPDIR}"
2019-04-01 10:52:25 +00:00
exit 2
fi
2019-03-22 16:47:36 +00:00
COUNT="./count"
if [ ! -f "${COUNT}" ]; then
touch "${COUNT}"
elif [ ! -w "${COUNT}" ]; then
${CLEAR}
echo -e "${RED}ERROR: Can't write to ${COUNT}!.${NC}"
ls -l "${COUNT}"
2019-04-01 10:52:25 +00:00
exit 2
2019-03-22 16:47:36 +00:00
fi
COMMANDS="./commands.sh"
if [ ! -f "${COMMANDS}" ] || [ ! -r "${COMMANDS}" ]; then
${CLEAR}
echo -e "${RED}ERROR: ${COMMANDS} does not exist or is not readable!.${NC}"
exit 3
ls -l "${COMMANDS}"
fi
2019-03-22 16:47:36 +00:00
# shellcheck source=./commands.sh
source "${COMMANDS}" "source"
2019-04-12 18:49:58 +00:00
URL='https://api.telegram.org/bot'$TOKEN
MSG_URL=$URL'/sendMessage'
LEAVE_URL=$URL'/leaveChat'
KICK_URL=$URL'/kickChatMember'
UNBAN_URL=$URL'/unbanChatMember'
PHO_URL=$URL'/sendPhoto'
AUDIO_URL=$URL'/sendAudio'
DOCUMENT_URL=$URL'/sendDocument'
STICKER_URL=$URL'/sendSticker'
VIDEO_URL=$URL'/sendVideo'
VOICE_URL=$URL'/sendVoice'
LOCATION_URL=$URL'/sendLocation'
VENUE_URL=$URL'/sendVenue'
ACTION_URL=$URL'/sendChatAction'
FORWARD_URL=$URL'/forwardMessage'
INLINE_QUERY=$URL'/answerInlineQuery'
ME_URL=$URL'/getMe'
DELETE_URL=$URL'/deleteMessage'
GETMEMBER_URL=$URL'/getChatMember'
FILE_URL='https://api.telegram.org/file/bot'$TOKEN'/'
UPD_URL=$URL'/getUpdates?offset='
GET_URL=$URL'/getFile'
2015-07-10 05:43:08 +00:00
OFFSET=0
declare -A USER MESSAGE URLS CONTACT LOCATION CHAT FORWARD REPLYTO
2015-07-10 05:43:08 +00:00
2019-04-12 18:49:58 +00:00
2016-06-09 12:11:33 +00:00
send_message() {
2019-04-08 09:58:55 +00:00
local text arg keyboard file lat long title address sent
[ "$2" = "" ] && return 1
2019-04-08 09:58:55 +00:00
local chat="$1"
text="$(echo "$2" | sed 's/ mykeyboardstartshere.*//g;s/ myfilelocationstartshere.*//g;s/ mylatstartshere.*//g;s/ mylongstartshere.*//g;s/ mytitlestartshere.*//g;s/ myaddressstartshere.*//g;s/ mykeyboardendshere.*//g')"
arg="$3"
[ "$arg" != "safe" ] && {
text="${text// mynewlinestartshere /$'\r\n'}"
no_keyboard="$(echo "$2" | sed '/mykeyboardendshere/!d;s/.*mykeyboardendshere.*/mykeyboardendshere/')"
2016-01-19 13:17:06 +00:00
keyboard="$(echo "$2" | sed '/mykeyboardstartshere /!d;s/.*mykeyboardstartshere //g;s/ myfilelocationstartshere.*//g;s/ mylatstartshere.*//g;s/ mylongstartshere.*//g;s/ mytitlestartshere.*//g;s/ myaddressstartshere.*//g;s/ mykeyboardendshere.*//g')"
2016-01-19 13:17:06 +00:00
file="$(echo "$2" | sed '/myfilelocationstartshere /!d;s/.*myfilelocationstartshere //g;s/ mykeyboardstartshere.*//g;s/ mylatstartshere.*//g;s/ mylongstartshere.*//g;s/ mytitlestartshere.*//g;s/ myaddressstartshere.*//g;s/ mykeyboardendshere.*//g')"
2016-01-19 13:17:06 +00:00
lat="$(echo "$2" | sed '/mylatstartshere /!d;s/.*mylatstartshere //g;s/ mykeyboardstartshere.*//g;s/ myfilelocationstartshere.*//g;s/ mylongstartshere.*//g;s/ mytitlestartshere.*//g;s/ myaddressstartshere.*//g;s/ mykeyboardendshere.*//g')"
long="$(echo "$2" | sed '/mylongstartshere /!d;s/.*mylongstartshere //g;s/ mykeyboardstartshere.*//g;s/ myfilelocationstartshere.*//g;s/ mylatstartshere.*//g;s/ mytitlestartshere.*//g;s/ myaddressstartshere.*//g;s/ mykeyboardendshere.*//g')"
title="$(echo "$2" | sed '/mytitlestartshere /!d;s/.*mylongstartshere //g;s/ mykeyboardstartshere.*//g;s/ myfilelocationstartshere.*//g;s/ mylatstartshere.*//g;s/ myaddressstartshere.*//g;s/ mykeyboardendshere.*//g')"
address="$(echo "$2" | sed '/myaddressstartshere /!d;s/.*mylongstartshere //g;s/ mykeyboardstartshere.*//g;s/ myfilelocationstartshere.*//g;s/ mylatstartshere.*//g;s/ mytitlestartshere.*//g;s/ mykeyboardendshere.*//g')"
}
if [ "$no_keyboard" != "" ]; then
echo "remove_keyboard $chat $text" > ${TMPDIR:-.}/prova
remove_keyboard "$chat" "$text"
sent=y
fi
if [ "$keyboard" != "" ]; then
if [[ "$keyboard" != *"["* ]]; then # pre 0.60 style
2019-04-17 07:34:02 +00:00
keyboard="[ ${keyboard//\" \"/\" \] , \[ \"} ]"
fi
2016-01-05 16:01:28 +00:00
send_keyboard "$chat" "$text" "$keyboard"
sent=y
fi
2016-01-19 13:17:06 +00:00
if [ "$file" != "" ]; then
send_file "$chat" "$file" "$text"
sent=y
fi
if [ "$lat" != "" ] && [ "$long" != "" ] && [ "$address" = "" ] && [ "$title" = "" ]; then
2016-01-19 13:17:06 +00:00
send_location "$chat" "$lat" "$long"
sent=y
2016-01-19 13:17:06 +00:00
fi
if [ "$lat" != "" ] && [ "$long" != "" ] && [ "$address" != "" ] && [ "$title" != "" ]; then
send_venue "$chat" "$lat" "$long" "$title" "$address"
sent=y
fi
2016-01-19 19:27:09 +00:00
if [ "$sent" != "y" ];then
send_text "$chat" "$text"
2016-01-19 19:27:09 +00:00
fi
2016-01-03 01:14:07 +00:00
}
2016-01-05 16:01:28 +00:00
send_text() {
case "$2" in
2019-04-12 18:49:58 +00:00
html_parse_mode*)
send_html_message "$1" "${2//html_parse_mode}"
;;
2019-04-12 18:49:58 +00:00
markdown_parse_mode*)
send_markdown_message "$1" "${2//markdown_parse_mode}"
;;
*)
send_normal_message "$1" "$2"
;;
esac
}
send_normal_message() {
text="$2"
until [ "$(echo -n "$text" | wc -m)" -eq "0" ]; do
res="$(curl -s "$MSG_URL" -d "chat_id=$1" --data-urlencode "text=${text:0:4096}")"
text="${text:4096}"
done
}
2016-03-19 01:08:25 +00:00
send_markdown_message() {
text="$2"
until [ "$(echo -n "$text" | wc -m)" -eq "0" ]; do
res="$(curl -s "$MSG_URL" -d "chat_id=$1" --data-urlencode "text=${text:0:4096}" -d "parse_mode=markdown" -d "disable_web_page_preview=true")"
text="${text:4096}"
done
}
send_html_message() {
text="$2"
until [ "$(echo -n "$text" | wc -m)" -eq "0" ]; do
2019-03-31 12:54:58 +00:00
res="$(curl -s "$MSG_URL" -d "chat_id=$1" --data-urlencode "text=${text:0:4096}" -d "parse_mode=html")"
text="${text:4096}"
done
2016-03-19 01:08:25 +00:00
}
delete_message() {
res="$(curl -s "$DELETE_URL" -F "chat_id=$1" -F "message_id=$2")"
}
# usage: status="$(get_chat_member_status "chat" "user")"
get_chat_member_status() {
curl -s "$GETMEMBER_URL" -F "chat_id=$1" -F "user_id=$2" | ./JSON.sh/JSON.sh -s | sed -n -e '/\["result","status"\]/ s/.*\][ \t]"\(.*\)"$/\1/p'
}
kick_chat_member() {
res="$(curl -s "$KICK_URL" -F "chat_id=$1" -F "user_id=$2")"
}
unban_chat_member() {
res="$(curl -s "$UNBAN_URL" -F "chat_id=$1" -F "user_id=$2")"
}
leave_chat() {
res="$(curl -s "$LEAVE_URL" -F "chat_id=$1")"
}
user_is_creator() {
2019-04-12 17:39:21 +00:00
if [ "${1:--}" = "${2:-+}" ] || [ "$(get_chat_member_status "$1" "$2")" = "creator" ]; then return 0; fi
return 1
}
user_is_admin() {
local me; me="$(get_chat_member_status "$1" "$2")"
2019-04-12 17:39:21 +00:00
if [ "${me}" = "creator" ] || [ "${me}" = "administrator" ]; then return 0; fi
return 1
}
2019-04-12 09:27:20 +00:00
user_is_botadmin() {
local admin; admin="$(head -n 1 "${BOTADMIN}")"
2019-04-12 17:39:21 +00:00
[ "${admin}" = "${1}" ] && return 0
[[ "${admin}" = "@*" ]] && [[ "${admin}" = "${2}" ]] && return 0
if [ "${admin}" = "?" ]; then echo "${1:-?}" >"${BOTADMIN}"; return 0; fi
2019-04-12 09:27:20 +00:00
return 1
}
2019-04-12 11:14:33 +00:00
user_is_allowed() {
local acl="$1"
2019-04-12 17:39:21 +00:00
[ "$1" = "" ] && return 1
2019-04-12 11:14:33 +00:00
grep -F -xq "${acl}:*:*" <"${BOTACL}" && return 0
[ "$2" != "" ] && acl="${acl}:$2"
grep -F -xq "${acl}:*" <"${BOTACL}" && return 0
[ "$3" != "" ] && acl="${acl}:$3"
grep -F -xq "${acl}" <"${BOTACL}"
}
answer_inline_query() {
case "$2" in
"article")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","title":"'$3'","message_text":"'$4'"}]'
;;
"photo")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","photo_url":"'$3'","thumb_url":"'$4'"}]'
;;
"gif")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","gif_url":"'$3'", "thumb_url":"'$4'"}]'
;;
"mpeg4_gif")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","mpeg4_url":"'$3'"}]'
;;
"video")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","video_url":"'$3'","mime_type":"'$4'","thumb_url":"'$5'","title":"'$6'"}]'
;;
"audio")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","audio_url":"'$3'","title":"'$4'"}]'
;;
"voice")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","voice_url":"'$3'","title":"'$4'"}]'
;;
"document")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","title":"'$3'","caption":"'$4'","document_url":"'$5'","mime_type":"'$6'"}]'
;;
"location")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","latitude":"'$3'","longitude":"'$4'","title":"'$5'"}]'
;;
"venue")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","latitude":"'$3'","longitude":"'$4'","title":"'$5'","address":"'$6'"}]'
;;
"contact")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"'$2'","id":"'$RANDOM'","phone_number":"'$3'","first_name":"'$4'"}]'
;;
# Cached media stored in Telegram server
"cached_photo")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"photo","id":"'$RANDOM'","photo_file_id":"'$3'"}]'
;;
"cached_gif")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"gif","id":"'$RANDOM'","gif_file_id":"'$3'"}]'
;;
"cached_mpeg4_gif")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"mpeg4_gif","id":"'$RANDOM'","mpeg4_file_id":"'$3'"}]'
;;
"cached_sticker")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"sticker","id":"'$RANDOM'","sticker_file_id":"'$3'"}]'
;;
"cached_document")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"document","id":"'$RANDOM'","title":"'$3'","document_file_id":"'$4'"}]'
;;
"cached_video")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"video","id":"'$RANDOM'","video_file_id":"'$3'","title":"'$4'"}]'
;;
"cached_voice")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"voice","id":"'$RANDOM'","voice_file_id":"'$3'","title":"'$4'"}]'
;;
"cached_audio")
2016-05-27 15:09:22 +00:00
InlineQueryResult='[{"type":"audio","id":"'$RANDOM'","audio_file_id":"'$3'"}]'
;;
esac
res="$(curl -s "$INLINE_QUERY" -F "inline_query_id=$1" -F "results=$InlineQueryResult")"
}
2019-04-17 07:34:02 +00:00
old_send_keyboard() {
local chat="$1"
local text="$2"
shift 2
local keyboard=init
OLDIFS=$IFS
IFS=$(echo -en "\"")
for f in "$@" ;do [ "$f" != " " ] && keyboard="$keyboard, [\"$f\"]";done
IFS=$OLDIFS
keyboard=${keyboard/init, /}
res="$(curl -s "$MSG_URL" --header "content-type: multipart/form-data" -F "chat_id=$chat" -F "text=$text" -F "reply_markup={\"keyboard\": [$keyboard],\"one_time_keyboard\": true}")"
}
2016-01-03 01:14:07 +00:00
send_keyboard() {
2019-04-17 07:34:02 +00:00
if [[ "$3" != *'['* ]]; then old_send_keyboard "$@"; return; fi
2016-01-05 16:01:28 +00:00
local chat="$1"
local text="$2"
2019-04-15 14:32:56 +00:00
local keyboard="$3"
res="$(curl -s "$MSG_URL" --header "content-type: multipart/form-data" -F "chat_id=$chat" -F "text=$text" -F "reply_markup={\"keyboard\": [${keyboard}],\"one_time_keyboard\": true}")"
2015-11-25 03:07:39 +00:00
}
remove_keyboard() {
local chat="$1"
local text="$2"
2019-04-12 18:49:58 +00:00
shift 2
res="$(curl -s "$MSG_URL" --header "content-type: multipart/form-data" -F "chat_id=$chat" -F "text=$text" -F "reply_markup={\"remove_keyboard\": true}")"
}
2016-01-06 16:11:56 +00:00
get_file() {
[ "$1" != "" ] && echo "$FILE_URL$(curl -s "$GET_URL" -F "file_id=$1" | ./JSON.sh/JSON.sh -s | JsonGetString '"result","file_path"')"
2016-01-06 16:11:56 +00:00
}
send_file() {
2016-01-17 16:46:24 +00:00
[ "$2" = "" ] && return
2019-04-08 09:58:55 +00:00
local CAPTION
2016-01-19 13:17:06 +00:00
local chat_id=$1
local file=$2
echo "$file" | grep -qE "$FILE_REGEX" || return
2016-01-19 13:17:06 +00:00
local ext="${file##*.}"
case $ext in
2016-06-09 12:11:33 +00:00
mp3|flac)
2016-01-17 16:46:24 +00:00
CUR_URL=$AUDIO_URL
WHAT=audio
STATUS=upload_audio
2019-04-08 09:58:55 +00:00
CAPTION="$3"
2016-01-17 16:46:24 +00:00
;;
png|jpg|jpeg|gif)
CUR_URL=$PHO_URL
WHAT=photo
STATUS=upload_photo
2019-04-08 09:58:55 +00:00
CAPTION="$3"
2016-01-17 16:46:24 +00:00
;;
webp)
CUR_URL=$STICKER_URL
WHAT=sticker
STATUS=
;;
mp4)
CUR_URL=$VIDEO_URL
WHAT=video
STATUS=upload_video
2019-04-08 09:58:55 +00:00
CAPTION="$3"
2016-01-17 16:46:24 +00:00
;;
ogg)
CUR_URL=$VOICE_URL
WHAT=voice
STATUS=
;;
*)
CUR_URL=$DOCUMENT_URL
WHAT=document
STATUS=upload_document
2019-04-08 09:58:55 +00:00
CAPTION="$3"
2016-01-17 16:46:24 +00:00
;;
esac
send_action "$chat_id" "$STATUS"
res="$(curl -s "$CUR_URL" -F "chat_id=$chat_id" -F "$WHAT=@$file" -F "caption=$CAPTION")"
2016-01-06 16:11:56 +00:00
}
2016-01-17 16:46:24 +00:00
# typing for text messages, upload_photo for photos, record_video or upload_video for videos, record_audio or upload_audio for audio files, upload_document for general files, find_location for location
send_action() {
2019-04-12 17:39:21 +00:00
[ "$2" = "" ] && return
res="$(curl -s "$ACTION_URL" -F "chat_id=$1" -F "action=$2")"
2016-01-17 16:46:24 +00:00
}
send_location() {
2019-04-12 17:39:21 +00:00
[ "$3" = "" ] && return
res="$(curl -s "$LOCATION_URL" -F "chat_id=$1" -F "latitude=$2" -F "longitude=$3")"
2016-01-17 16:46:24 +00:00
}
send_venue() {
2019-04-12 17:39:21 +00:00
[ "$5" = "" ] && return
[ "$6" != "" ] add="-F \"foursquare_id=$6\""
res="$(curl -s "$VENUE_URL" -F "chat_id=$1" -F "latitude=$2" -F "longitude=$3" -F "title=$4" -F "address=$5")"
}
2019-04-16 11:29:49 +00:00
forward_message() {
2019-04-12 17:39:21 +00:00
[ "$3" = "" ] && return
res="$(curl -s "$FORWARD_URL" -F "chat_id=$1" -F "from_chat_id=$2" -F "message_id=$3")"
2016-01-17 16:46:24 +00:00
}
2019-04-16 11:29:49 +00:00
forward() { # backward compatibility
forward_message "$@" || return
}
background() {
echo "${CHAT[ID]}:$2:$1" >"${TMPDIR:-.}/${copname}$2-back.cmd"
startproc "$1" "back-$2-"
}
2016-01-05 16:01:28 +00:00
startproc() {
killproc "$2"
2019-04-14 18:30:59 +00:00
local fifo="$2${copname}"
mkfifo "${TMPDIR:-.}/${fifo}"
tmux new-session -d -s "${fifo}" "$1 &>${TMPDIR:-.}/${fifo}; echo imprettydarnsuredatdisisdaendofdacmd>${TMPDIR:-.}/${fifo}"
tmux new-session -d -s "sendprocess_${fifo}" "bash $SCRIPT outproc ${CHAT[ID]} ${fifo}"
}
checkback() {
checkproc "back-$1-"
}
checkproc() {
2019-04-15 14:32:56 +00:00
tmux ls | grep -q "$1${copname}"; res=$?; return $?
}
killback() {
killproc "back-$1-"
rm -f "${TMPDIR:-.}/${copname}$1-back.cmd"
2016-01-02 20:51:45 +00:00
}
2016-01-06 16:11:56 +00:00
2016-04-15 17:37:44 +00:00
killproc() {
local fifo="$1${copname}"
(tmux kill-session -t "${fifo}"; echo imprettydarnsuredatdisisdaendofdacmd>"${TMPDIR:-.}/${fifo}"; tmux kill-session -t "sendprocess_${fifo}"; rm -f -r "${TMPDIR:-.}/${fifo}")2>/dev/null
2016-04-15 17:37:44 +00:00
}
2016-01-03 01:14:07 +00:00
inproc() {
tmux send-keys -t "$copname" "${MESSAGE[0]} ${URLS[*]}
2016-01-05 16:01:28 +00:00
"
2016-01-03 01:14:07 +00:00
}
process_updates() {
MAX_PROCESS_NUMBER=$(echo "$UPDATE" | sed '/\["result",[0-9]*\]/!d' | tail -1 | sed 's/\["result",//g;s/\].*//g')
for ((PROCESS_NUMBER=0; PROCESS_NUMBER<=MAX_PROCESS_NUMBER; PROCESS_NUMBER++)); do
2019-04-12 17:39:21 +00:00
if [ "$1" = "test" ]; then
process_client "$1"
else
process_client "$1" &
fi
done
}
2019-04-13 18:53:59 +00:00
JsonGetString() {
sed -n -e '/\['"$1"'\]/ s/.*\][ \t]"\(.*\)"$/\1/p'
}
JsonGetValue() {
sed -n -e '/\['"$1"'\]/ s/.*\][ \t]//p'
}
process_client() {
local TMP="${TMPDIR:-.}/$RANDOM$RANDOM-MESSAGE"
2019-03-26 16:49:47 +00:00
echo "$UPDATE" >"$TMP"
# Message
2019-04-13 18:53:59 +00:00
MESSAGE[0]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","text"' <"$TMP")" | sed 's#\\/#/#g')"
MESSAGE[ID]="$(JsonGetValue '"result",'$PROCESS_NUMBER',"message","message_id"' <"$TMP" )"
# Chat
2019-04-13 18:53:59 +00:00
CHAT[ID]="$(JsonGetValue '"result",'$PROCESS_NUMBER',"message","chat","id"' <"$TMP" )"
CHAT[FIRST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","chat","first_name"' <"$TMP")")"
CHAT[LAST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","chat","last_name"' <"$TMP")")"
CHAT[USERNAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","chat","username"' <"$TMP")")"
CHAT[TITLE]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","chat","title"' <"$TMP")")"
CHAT[TYPE]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","chat","type"' <"$TMP")")"
CHAT[ALL_MEMBERS_ARE_ADMINISTRATORS]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","chat","all_members_are_administrators"' <"$TMP")")"
2016-01-17 16:46:24 +00:00
# User
2019-04-13 18:53:59 +00:00
USER[ID]="$(JsonGetValue '"result",'$PROCESS_NUMBER',"message","from","id"' <"$TMP" )"
USER[FIRST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","from","first_name"' <"$TMP")")"
USER[LAST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","from","last_name"' <"$TMP")")"
USER[USERNAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","from","username"' <"$TMP")")"
2016-01-17 16:46:24 +00:00
# in reply to message from
2019-04-13 18:53:59 +00:00
REPLYTO[UID]="$(JsonGetValue '"result",'$PROCESS_NUMBER',"message","reply_to_message","from","id"' <"$TMP" )"
if [ "${REPLYTO[UID]}" != "" ]; then
2019-04-13 18:53:59 +00:00
REPLYTO[0]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","reply_to_message","text"' <"$TMP")")"
REPLYTO[ID]="$(JsonGetValue '"result",'$PROCESS_NUMBER',"message","reply_to_message","message_id"' <"$TMP")"
2019-04-13 18:53:59 +00:00
REPLYTO[FIRST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","reply_to_message","from","first_name"' <"$TMP")")"
REPLYTO[LAST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","reply_to_message","from","last_name"' <"$TMP")")"
REPLYTO[USERNAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","reply_to_message","from","username"' <"$TMP")")"
fi
# forwarded message from
2019-04-13 18:53:59 +00:00
FORWARD[UID]="$(JsonGetValue '"result",'$PROCESS_NUMBER',"message","forward_from","id"' <"$TMP" )"
if [ "${FORWARD[UID]}" != "" ]; then
FORWARD[ID]="${MESSAGE[ID]}" # same as message ID
2019-04-13 18:53:59 +00:00
FORWARD[FIRST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","forward_from","first_name"' <"$TMP")")"
FORWARD[LAST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","forward_from","last_name"' <"$TMP")")"
FORWARD[USERNAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","forward_from","username"' <"$TMP")")"
fi
2016-01-17 16:46:24 +00:00
# Audio
2019-04-13 18:53:59 +00:00
URLS[AUDIO]="$(get_file "$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","audio","file_id"' <"$TMP")")")"
2016-01-19 19:27:09 +00:00
# Document
2019-04-13 18:53:59 +00:00
URLS[DOCUMENT]="$(get_file "$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","document","file_id"' <"$TMP")")")"
2016-01-17 16:46:24 +00:00
# Photo
2019-04-13 18:53:59 +00:00
URLS[PHOTO]="$(get_file "$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","photo",.*,"file_id"' <"$TMP")")")"
2016-01-17 16:46:24 +00:00
# Sticker
2019-04-13 18:53:59 +00:00
URLS[STICKER]="$(get_file "$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","sticker","file_id"' <"$TMP")")")"
2016-01-17 16:46:24 +00:00
# Video
2019-04-13 18:53:59 +00:00
URLS[VIDEO]="$(get_file "$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","video","file_id"' <"$TMP")")")"
2016-01-17 16:46:24 +00:00
# Voice
2019-04-13 18:53:59 +00:00
URLS[VOICE]="$(get_file "$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","voice","file_id"' <"$TMP")")")"
2016-01-17 16:46:24 +00:00
# Contact
2019-04-13 18:53:59 +00:00
CONTACT[NUMBER]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","contact","phone_number"' <"$TMP")")"
CONTACT[FIRST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","contact","first_name"' <"$TMP")")"
CONTACT[LAST_NAME]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","contact","last_name"' <"$TMP")")"
CONTACT[USER_ID]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","contact","user_id"' <"$TMP")")"
2016-01-17 16:46:24 +00:00
# Caption
2019-04-13 18:53:59 +00:00
CAPTION="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","caption"' <"$TMP")")"
2016-01-17 16:46:24 +00:00
# Location
2019-04-13 18:53:59 +00:00
LOCATION[LONGITUDE]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","location","longitude"' <"$TMP")")"
LOCATION[LATITUDE]="$(JsonDecode "$(JsonGetString '"result",'$PROCESS_NUMBER',"message","location","latitude"' <"$TMP")")"
NAME="$(echo "${URLS[*]}" | sed 's/.*\///g')"
2019-03-26 16:49:47 +00:00
rm "$TMP"
2016-01-17 16:46:24 +00:00
# Tmux
2019-04-12 18:49:58 +00:00
copname="$ME"_"${CHAT[ID]}"
2016-01-17 16:46:24 +00:00
2019-04-12 18:49:58 +00:00
source commands.sh
tmpcount="COUNT${CHAT[ID]}"
2019-04-12 18:49:58 +00:00
grep -q "$tmpcount" <"${COUNT}" >/dev/null 2>&1 || echo "$tmpcount">>${COUNT}
# To get user count execute bash bashbot.sh count
}
# get bot name
getBotName() {
res="$(curl -s "$ME_URL")"
echo "$res" | ./JSON.sh/JSON.sh -s | JsonGetString '"result","username"'
}
ME="$(getBotName)"
if [ "$ME" = "" ]; then
2019-04-19 15:31:01 +00:00
if [ "$(cat "${TOKENFILE}")" = "bashbottestscript" ]; then
ME="bashbottestscript"
else
echo -e "${RED}ERROR: Can't connect to Telegram Bot! May be your TOKEN is invalid ...${NC}"
exit 1
2019-04-19 15:31:01 +00:00
fi
fi
# use phyton JSON to decode JSON UFT-8, provide bash implementaion as fallback
if which python >/dev/null 2>&1 || which phyton2 >/dev/null 2>&1; then
JsonDecode() {
printf '"%s\\n"' "${1//\"/\\\"}" | python -c 'import json, sys; sys.stdout.write(json.load(sys.stdin).encode("utf-8"))'
}
else
# pure bash implementaion, done by KayM (@gnadelwartz)
# see https://stackoverflow.com/a/55666449/9381171
JsonDecode() {
local out="$1"
local remain=""
2019-04-15 08:55:22 +00:00
local regexp='(.*)\\u[dD]([0-9a-fA-F]{3})\\u[dD]([0-9a-fA-F]{3})(.*)'
while [[ "${out}" =~ $regexp ]] ; do
# match 2 \udxxx hex values, calculate new U, then split and replace
local W1="$(( ( 0xd${BASH_REMATCH[2]} & 0x3ff) <<10 ))"
local W2="$(( 0xd${BASH_REMATCH[3]} & 0x3ff ))"
U="$(( ( W1 | W2 ) + 0x10000 ))"
remain="$(printf '\\U%8.8x' "${U}")${BASH_REMATCH[4]}${remain}"
out="${BASH_REMATCH[1]}"
done
echo -e "${out}${remain}"
}
fi
2016-03-20 21:34:55 +00:00
# source the script with source as param to use functions in other scripts
2019-04-12 17:39:21 +00:00
while [ "$1" = "startbot" ]; do {
2015-07-10 05:43:08 +00:00
UPDATE="$(curl -s "$UPD_URL$OFFSET" | ./JSON.sh/JSON.sh)"
2015-07-10 05:43:08 +00:00
2016-01-06 16:11:56 +00:00
# Offset
2019-04-19 16:35:51 +00:00
OFFSET="$(echo "$UPDATE" | grep '\["result",[0-9]*,"update_id"\]' | tail -1 | cut -f 2)"
2015-07-10 05:43:08 +00:00
OFFSET=$((OFFSET+1))
2019-03-30 14:14:13 +00:00
if [ "$OFFSET" != "1" ]; then
2019-04-12 17:39:21 +00:00
if [ "$2" = "test" ]; then
process_updates "$2"
2016-06-09 13:40:39 +00:00
else
process_updates "$2" &
2016-06-09 13:40:39 +00:00
fi
2015-07-10 07:32:34 +00:00
fi
2015-07-10 05:43:08 +00:00
2016-01-05 16:01:28 +00:00
}; done
case "$1" in
"outproc")
until [ "$line" = "imprettydarnsuredatdisisdaendofdacmd" ];do
2019-03-30 14:14:13 +00:00
line=""
read -r -t 10 line
[ "$line" != "" ] && [ "$line" != "imprettydarnsuredatdisisdaendofdacmd" ] && send_message "$2" "$line"
done <"${TMPDIR:-.}/$3"
rm -f -r "${TMPDIR:-.}/$3"
;;
"count")
2019-04-08 10:40:07 +00:00
echo "A total of $(wc -l <"${COUNT}") users used me."
exit
;;
"broadcast")
2019-04-08 10:40:07 +00:00
NUMCOUNT="$(wc -l <"${COUNT}")"
echo "Sending the broadcast $* to $NUMCOUNT users."
[ "$NUMCOUNT" -gt "300" ] && sleep="sleep 0.5"
shift
2019-04-08 10:40:07 +00:00
while read -r f; do send_message "${f//COUNT}" "$*"; $sleep; done <"${COUNT}"
;;
2016-04-17 12:13:28 +00:00
"start")
${CLEAR}
tmux kill-session -t "$ME" &>/dev/null
tmux new-session -d -s "$ME" "bash $SCRIPT startbot" && echo -e "${GREEN}Bot started successfully.${NC}"
echo "Tmux session name $ME" || echo -e "${RED}An error occurred while starting the bot. ${NC}"
send_markdown_message "${CHAT[ID]}" "*Bot started*"
2016-04-17 12:13:28 +00:00
;;
2019-03-25 10:15:07 +00:00
"init") # adjust users and permissions
[[ "$(id -u)" -eq "0" ]] && RUNUSER="nobody"
echo -n "Enter User to run basbot [$RUNUSER]: "
read -r TOUSER
[ "$TOUSER" = "" ] && TOUSER="$RUNUSER"
2019-04-08 09:58:55 +00:00
if ! compgen -u "$TOUSER" >/dev/null 2>&1; then
echo -e "${RED}User \"$TOUSER\" not found!${NC}"
2019-04-01 10:52:25 +00:00
exit 3
2019-03-25 10:15:07 +00:00
else
2019-04-19 15:31:01 +00:00
echo "Adjusting user \"${TOUSER}\" files and permissions ..."
sed -i '/^[# ]*runas=/ s/runas=.*$/runas="'$TOUSER'"/' bashbot.rc
chown -R "$TOUSER" . ./*
2019-03-25 10:15:07 +00:00
chmod 711 .
chmod -R a-w ./*
chmod -R u+w "${COUNT}" "${TMPDIR}" "${BOTADMIN}" ./*.log 2>/dev/null
2019-04-19 15:31:01 +00:00
chmod -R o-r,o-w "${COUNT}" "${TMPDIR}" "${TOKENFILE}" "${BOTADMIN}" "${BOTACL}" 2>/dev/null
2019-03-25 10:15:07 +00:00
ls -la
exit
fi
;;
"background" | "resumeback")
${CLEAR}
echo -e "${GREEN}Restart background processes ...${NC}"
for FILE in "${TMPDIR:-.}/"*-back.cmd; do
2019-04-12 17:39:21 +00:00
if [ "${FILE}" = "${TMPDIR:-.}/*-back.cmd" ]; then
echo -e "${RED}No background processes to start.${NC}"; break
else
2019-04-12 09:27:20 +00:00
RESTART="$(< "${FILE}")"
CHAT[ID]="${RESTART%%:*}"
JOB="${RESTART#*:}"
PROG="${JOB#*:}"
JOB="${JOB%:*}"
fifo="back-${JOB}-${ME}_${CHAT[ID]}" # compose fifo from jobname, $ME (botname) and CHAT[ID]
echo "restartbackground ${PROG} ${fifo}"
( tmux kill-session -t "${fifo}"; tmux kill-session -t "sendprocess_${fifo}"; rm -f -r "${TMPDIR:-.}/${fifo}") 2>/dev/null
mkfifo "${TMPDIR:-.}/${fifo}"
tmux new-session -d -s "${fifo}" "${PROG} &>${TMPDIR:-.}/${fifo}; echo imprettydarnsuredatdisisdaendofdacmd>${TMPDIR:-.}/${fifo}"
tmux new-session -d -s "sendprocess_${fifo}" "bash $SCRIPT outproc ${CHAT[ID]} ${fifo}"
fi
done
;;
2016-04-17 12:13:28 +00:00
"kill")
${CLEAR}
tmux kill-session -t "$ME" &>/dev/null
send_markdown_message "${CHAT[ID]}" "*Bot stopped*"
echo -e "${GREEN}OK. Bot stopped successfully.${NC}"
2016-04-17 12:13:28 +00:00
;;
"killback" | "suspendback")
${CLEAR}
echo -e "${GREEN}Stopping background processes ...${NC}"
for FILE in "${TMPDIR:-.}/"*-back.cmd; do
2019-04-12 17:39:21 +00:00
if [ "${FILE}" = "${TMPDIR:-.}/*-back.cmd" ]; then
echo -e "${RED}No background processes.${NC}"; break
else
2019-04-12 09:27:20 +00:00
REMOVE="$(< "${FILE}")"
JOB="${REMOVE#*:}"
fifo="back-${JOB%:*}-${ME}_${REMOVE%%:*}"
echo "killbackground ${fifo}"
2019-04-12 17:39:21 +00:00
[ "$1" = "killback" ] && rm -f "${FILE}" # remove job
( tmux kill-session -t "${fifo}"; tmux kill-session -t "sendprocess_${fifo}"; rm -f -r "${TMPDIR:-.}/${fifo}") 2>/dev/null
fi
done
;;
2016-04-17 12:13:28 +00:00
"help")
${CLEAR}
2019-04-09 11:41:38 +00:00
less "README.txt"
2019-04-01 10:52:25 +00:00
exit
;;
"attach")
tmux attach -t "$ME"
;;
"source")
echo "OK"
2019-04-01 10:52:25 +00:00
exit
;;
*)
echo -e "${RED}${ME}: BAD REQUEST${NC}"
echo -e "${RED}Available arguments: outproc, count, broadcast, start, suspendback, resumeback, kill, killback, help, attach${NC}"
2019-04-01 10:52:25 +00:00
exit 4
2016-04-17 12:13:28 +00:00
;;
esac
# warn if root
if [[ "$(id -u)" -eq "0" ]] ; then
echo -e "\\n${ORANGE}WARNING: ${SCRIPT} was started as ROOT (UID 0)!${NC}"
echo -e "${ORANGE}You are at HIGH RISK when processing user input with root privilegs!${NC}"
fi